package be.iminds.ilabt.jfed.experimenter_gui.canvas.rspec;

import be.iminds.ilabt.jfed.experimenter_gui.JFedConfiguration;
import be.iminds.ilabt.jfed.highlevel.model.AuthorityList;
import be.iminds.ilabt.jfed.rspec.model.javafx_impl.*;

import javax.inject.Inject;
import javax.inject.Singleton;

/**
 * User: twalcari
 * Date: 12/2/2014
 * Time: 16:18
 */
@Singleton
public class CanvasNodeFactory {

    private final AuthorityList authorityList;
    private final JFedConfiguration config;

    @Inject
    public CanvasNodeFactory(AuthorityList authorityList, JFedConfiguration config) {
        this.authorityList = authorityList;
        this.config = config;
    }

    public RspecCanvasNode createRspecCanvasNode(FXRspecNode node){
        if (node instanceof DelayRspecNode)
            return new DelayRspecCanvasNode((DelayRspecNode) node, authorityList, config);
        else
            return new RspecCanvasNode(node, authorityList, config);
    }


    public RspecChannelCanvasNode createRspecChannelCanvasNode(FXRspecChannel rspecChannel) {
        return new RspecChannelCanvasNode(rspecChannel, authorityList, config);
    }

    public RspecGTSNode createRspecGTSNode(FXGeantTestbedType gtt) {
        return new RspecGTSNode(gtt);

    }

    public AddressPoolCanvasNode createAddressPoolCanvasNode(FXAddressPool addressPool){
        return new AddressPoolCanvasNode(addressPool, authorityList,config);
    }
}
