package be.iminds.ilabt.jfed.experimenter_gui.gts_editor.views;

import be.iminds.ilabt.jfed.experimenter_gui.JFedConfiguration;
import be.iminds.ilabt.jfed.experimenter_gui.canvas.rspec.CanvasNodeFactory;
import be.iminds.ilabt.jfed.experimenter_gui.gts_editor.GTSModelEditor;
import be.iminds.ilabt.jfed.highlevel.model.AuthorityList;

import javax.inject.Inject;
import javax.inject.Singleton;

/**
 * User: twalcari
 * Date: 5/21/2015
 * Time: 11:16
 */
@Singleton
public class GTSViewsFactory {

    private final JFedConfiguration conf;
    private final CanvasNodeFactory canvasNodeFactory;
    private final AuthorityList authorityList;

    @Inject
    public GTSViewsFactory(JFedConfiguration conf, CanvasNodeFactory canvasNodeFactory, AuthorityList authorityList) {

        this.conf = conf;
        this.canvasNodeFactory = canvasNodeFactory;
        this.authorityList = authorityList;
    }


    public EditableGTSCanvasEditorView createEditableGTSCanvasEditorView(GTSModelEditor modelEditor) {
        return new EditableGTSCanvasEditorView(modelEditor, conf, canvasNodeFactory, authorityList);
    }

    public RawGtsDslEditor createRawGtsDslEditor(String dsl, boolean dirty){
        return new RawGtsDslEditor(dsl, dirty);
    }

}
