package be.iminds.ilabt.jfed;

import be.iminds.ilabt.jfed.lowlevel.ServerType;
import be.iminds.ilabt.jfed.lowlevel.TestCertHelper;
import be.iminds.ilabt.jfed.lowlevel.authority.AuthorityListModel;
import be.iminds.ilabt.jfed.lowlevel.authority.SfaAuthority;
import be.iminds.ilabt.jfed.util.GeniUrn;
import com.google.inject.Guice;
import com.google.inject.Injector;
import org.testng.annotations.Test;

import java.net.MalformedURLException;
import java.net.URL;

import static org.hamcrest.MatcherAssert.assertThat;
import static org.hamcrest.Matchers.equalTo;
import static org.hamcrest.Matchers.hasSize;
import static org.testng.Assert.assertNotNull;

/**
 * TestAuthoritiesModuleTest
 */
public class TestAuthoritiesModuleTest {
    @Test
    public void testExampleAuth() throws GeniUrn.GeniUrnParseException, MalformedURLException {
//        TestAuthoritiesModule testAuthoritiesModule = new TestAuthoritiesModule(
//                new TestAuthoritiesModule.AMConfig(true/*hasV2*/, true/*hasV3*/, false/*hasUpToDateAdv*/, false/*hasAny*/),
//                new TestAuthoritiesModule.AMConfig(true/*hasV2*/, false/*hasV3*/, false/*hasUpToDateAdv*/, false/*hasAny*/),
//                new TestAuthoritiesModule.AMConfig());
        TestAuthoritiesModule testAuthoritiesModule = new TestAuthoritiesModule();
        Injector injector = Guice.createInjector(testAuthoritiesModule, new CorePreferencesModule(), new MockHttpRepliesTestCoreModule(), new TestUserModule());
        AuthorityListModel authorityListModel = injector.getInstance(AuthorityListModel.class);
        TestCertHelper testCertHelper = injector.getInstance(TestCertHelper.class);

        GeniUrn exampleUrn = testAuthoritiesModule.getTestAuthorityUrn();
        GeniUrn exampleUrn2 = testAuthoritiesModule.getTestAuthority2Urn();
        GeniUrn exampleUrn3 = GeniUrn.parse(TestCertHelper.scsUrn);
        assertNotNull(exampleUrn);
        assertNotNull(exampleUrn2);
        assertNotNull(exampleUrn3);

        assertThat(authorityListModel.getAuthorities(), hasSize(4));

        SfaAuthority exampleAuth = authorityListModel.getByUrnExact(exampleUrn);
        assertNotNull(exampleAuth);
        assertNotNull(exampleAuth.getUrn());
        assertThat(exampleAuth.getUrn(), equalTo(exampleUrn));
        assertThat(exampleAuth.getHrn(), equalTo(TestAuthoritiesModule.hrnA));
        assertThat(exampleAuth.getUrl(ServerType.GeniServerRole.AM, 3), equalTo(new URL(TestAuthoritiesModule.urlA_am3)));


        SfaAuthority exampleAuth2 = authorityListModel.getByUrnExact(exampleUrn2);
        assertNotNull(exampleAuth2);
        assertNotNull(exampleAuth2.getUrn());
        assertThat(exampleAuth2.getUrn(), equalTo(exampleUrn2));
        assertThat(exampleAuth2.getHrn(), equalTo(TestAuthoritiesModule.hrnB));
        assertThat(exampleAuth2.getUrl(ServerType.GeniServerRole.AM, 2), equalTo(new URL(TestAuthoritiesModule.urlB_am2)));


        SfaAuthority exampleAuth3 = authorityListModel.getByUrnExact(exampleUrn3);
        assertNotNull(exampleAuth3);
        assertNotNull(exampleAuth3.getUrn());
        assertThat(exampleAuth3.getUrn(), equalTo(exampleUrn3));
        assertThat(exampleAuth3.getHrn(), equalTo(TestAuthoritiesModule.hrnC));
        assertThat(exampleAuth3.getUrl(ServerType.GeniServerRole.SCS, 1), equalTo(new URL(TestAuthoritiesModule.urlC_scs)));
    }
}
